Integer
Date: 2020-06-16

org.jpl7

## Class Integer

- java.lang.Object
- - org.jpl7.Term
  - - org.jpl7.Integer

-     public class Integer
      extends Term

  Integer is a specialised Term representing a Prolog integer value; if the value fits, it is held in a long field, else as a BigInteger.

       Integer i = new Integer(1024);

  Once constructed, the value of an Integer instance cannot be altered. An Integer can be used (and re-used) as an argument of Compounds. Beware confusing jpl.Integer with java.lang.Integer.

  Copyright (C) 2004 Paul Singleton

  Copyright (C) 1998 Fred Dushin

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  See Also:
    `Term`, `Compound`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.math.BigInteger` | `bigValue` the Integer's immutable BigInteger value, iff too big for a long, else null
    `protected long` | `value` the Integer's immutable long value, iff small enough

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Integer(java.math.BigInteger value)`
    `Integer(long value)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Term[]` | `args()` The arguments of this Term.
    `java.math.BigInteger` | `bigValue()` Returns the value of this Integer as a java.math.BigInteger, whether or not it fits in a long
    `double` | `doubleValue()` Returns the value of this Integer converted to a double (perhaps Double.NEGATIVE_INFINITY or Double.POSITIVE_INFINITY)
    `boolean` | `equals(java.lang.Object o)` two Integer instances are equal if their values are equal
    `float` | `floatValue()` Returns the value of this Integer converted to a float
    `boolean` | `hasFunctor(java.math.BigInteger val, int arity)` whether this Integer's functor has (BigInteger) 'name' and 'arity' (c.f.
    `boolean` | `hasFunctor(long val, int arity)` whether this Integer's functor has (long) 'name' and 'arity' (c.f.
    `int` | `hashCode()`
    `int` | `intValue()` Returns the value of this Integer as an int if possible, else throws a JPLException
    `boolean` | `isBig()` Tests whether this Integer's value is too big to represent as a long.
    `long` | `longValue()` Returns the value of this org.jpl7.Integer as a long
    `protected void` | `put(java.util.Map<java.lang.String,term_t> varnames_to_vars, term_t term)` To convert an Integer into a Prolog term, we put its value into the term_t.
    `java.lang.String` | `toString()` a Prolog source text representation of this Integer's value
    `int` | `type()` the type of this term, as "Prolog.INTEGER"
    `java.lang.String` | `typeName()` the name of the type of this term, as "Integer"

    - ### Methods inherited from class org.jpl7.Term

      `arg, arity, atomListToStringArray, atomType, getSubst, getSubsts, getTerm, getTerm, hasFunctor, hasFunctor, intArrayArrayToList, intArrayToList, isAtom, isAtomOfNameType, isBigInteger, isCompound, isFloat, isInteger, isJFalse, isJNull, isJRef, isJTrue, isJVoid, isList, isList, isListNil, isListPair, isVariable, jrefToObject, listLength, listLength, listToTermArray, listToTermArray, name, object, objectToJRef, put, putParams, putParams, putParams1, putParams2, putTerm, putTerms, ref, setName, stringArrayToList, termArrayToList, textParamsToTerm, textToTerm, toString, toTermArray`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### value

          protected final long value

      the Integer's immutable long value, iff small enough

    - #### bigValue

          protected final java.math.BigInteger bigValue

      the Integer's immutable BigInteger value, iff too big for a long, else null

  - ### Constructor Detail

    - #### Integer

          public Integer(long value)

      Parameters:
        `value` - This Integer's intended (long) value

    - #### Integer

          public Integer(java.math.BigInteger value)

      Parameters:
        `value` - This Integer's intended (BigInteger) value

  - ### Method Detail

    - #### args

          public Term[] args()

      Description copied from class: `Term`
      The arguments of this Term.

      Note that a SWI Prolog 7.x compound term can have zero arguments.

      This method returns an empty Term[] from an Atom, Float, Integer or JRef, approximating the behaviour of SWI Prolog's =../2

      Overrides:
        `args` in class `Term`
      Returns:
        the arguments of a Compound

    - #### bigValue

          public final java.math.BigInteger bigValue()

      Returns the value of this Integer as a java.math.BigInteger, whether or not it fits in a long
      Overrides:
        `bigValue` in class `Term`
      Returns:
        the value of this Integer as a java.math.BigInteger, whether or not it fits in a long

    - #### doubleValue

          public final double doubleValue()

      Returns the value of this Integer converted to a double (perhaps Double.NEGATIVE_INFINITY or Double.POSITIVE_INFINITY)
      Overrides:
        `doubleValue` in class `Term`
      Returns:
        the value of this Integer converted to a double (perhaps Double.NEGATIVE_INFINITY or Double.POSITIVE_INFINITY)

    - #### equals

          public boolean equals(java.lang.Object o)

      two Integer instances are equal if their values are equal
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `o` - The Object to compare (not necessarily an Integer)
      Returns:
        true if the Object satisfies the above condition

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### floatValue

          public final float floatValue()

      Returns the value of this Integer converted to a float
      Overrides:
        `floatValue` in class `Term`
      Returns:
        the value of this Integer converted to a float

    - #### hasFunctor

          public final boolean hasFunctor(long val,
                                          int arity)

      whether this Integer's functor has (long) 'name' and 'arity' (c.f. traditional functor/3)
      Overrides:
        `hasFunctor` in class `Term`
      Parameters:
        `val` - a possible name for the functor of a term
        `arity` - an arity 0+
      Returns:
        whether this Integer's functor has (long) 'name' and 'arity'

    - #### hasFunctor

          public final boolean hasFunctor(java.math.BigInteger val,
                                          int arity)

      whether this Integer's functor has (BigInteger) 'name' and 'arity' (c.f. traditional functor/3)
      Overrides:
        `hasFunctor` in class `Term`
      Parameters:
        `val` - a possible name for the functor of a term
        `arity` - an arity 0+
      Returns:
        whether this Integer's functor has (BigInteger) 'name' and 'arity'

    - #### intValue

          public final int intValue()

      Returns the value of this Integer as an int if possible, else throws a JPLException
      Overrides:
        `intValue` in class `Term`
      Returns:
        the int value of this Integer
      Throws:
        `JPLException` - if the value of this Integer is too great to be represented as a Java int

    - #### isBig

          public final boolean isBig()

      Description copied from class: `Term`
      Tests whether this Integer's value is too big to represent as a long.

      Use this in contexts where the Term is known to be an Integer.

      Overrides:
        `isBig` in class `Term`
      Returns:
        whether this Integer's value is too big to represent as a long
      See Also:
        `Term.isBigInteger()`

    - #### longValue

          public final long longValue()

      Returns the value of this org.jpl7.Integer as a long
      Overrides:
        `longValue` in class `Term`
      Returns:
        the value of this org.jpl7.Integer as a long

    - #### put

          protected final void put(java.util.Map<java.lang.String,term_t> varnames_to_vars,
                                   term_t term)

      To convert an Integer into a Prolog term, we put its value into the term_t.
      Specified by:
        `put` in class `Term`
      Parameters:
        `varnames_to_vars` - A Map from variable names to Prolog variables.
        `term` - A (previously created) term_t which is to be set to a Prolog integer

    - #### toString

          public java.lang.String toString()

      a Prolog source text representation of this Integer's value
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a Prolog source text representation of this Integer's value

    - #### type

          public final int type()

      the type of this term, as "Prolog.INTEGER"
      Specified by:
        `type` in class `Term`
      Returns:
        the type of this term, as "Prolog.INTEGER"

    - #### typeName

          public java.lang.String typeName()

      the name of the type of this term, as "Integer"
      Specified by:
        `typeName` in class `Term`
      Returns:
        the name of the type of this term, as "Integer"